import { VIDEO_TRANSCODING_FPS } from '../../initializers/constants.js';
export function computeOutputFPS(options) {
    const { resolution } = options;
    let fps = options.inputFPS;
    if (resolution !== undefined &&
        resolution < VIDEO_TRANSCODING_FPS.KEEP_ORIGIN_FPS_RESOLUTION_MIN &&
        fps > VIDEO_TRANSCODING_FPS.AVERAGE) {
        fps = getClosestFramerateStandard({ fps, type: 'STANDARD' });
    }
    if (fps < VIDEO_TRANSCODING_FPS.HARD_MIN) {
        throw new Error(`Cannot compute FPS because ${fps} is lower than our minimum value ${VIDEO_TRANSCODING_FPS.HARD_MIN}`);
    }
    if (fps < VIDEO_TRANSCODING_FPS.SOFT_MIN)
        fps = VIDEO_TRANSCODING_FPS.SOFT_MIN;
    if (fps > VIDEO_TRANSCODING_FPS.SOFT_MAX)
        fps = getClosestFramerateStandard({ fps, type: 'HD_STANDARD' });
    return fps;
}
function getClosestFramerateStandard(options) {
    const { fps, type } = options;
    return VIDEO_TRANSCODING_FPS[type].slice(0)
        .sort((a, b) => fps % a - fps % b)[0];
}
//# sourceMappingURL=framerate.js.map